/*******************************************************************************
 * Copyright (c) 2008 Innoopract Informationssysteme GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     Innoopract Informationssysteme GmbH - initial API and implementation
 ******************************************************************************/
package org.eclipse.rap.help.internal.integration;

import java.net.MalformedURLException;
import java.net.URL;
import java.text.MessageFormat;

import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.rwt.RWT;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.IWorkbenchWindowActionDelegate;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.browser.IWebBrowser;
import org.eclipse.ui.browser.IWorkbenchBrowserSupport;

public final class OpenHelpAction implements IWorkbenchWindowActionDelegate {

  public void init( final IWorkbenchWindow window ) {
  }

  public void run( final IAction action ) {
    IWorkbench workbench = PlatformUI.getWorkbench();
    IWorkbenchBrowserSupport browserSupport = workbench.getBrowserSupport();
    try {
      IWebBrowser browser = browserSupport.createBrowser( "helpBrowser" );
      browser.openURL( getUrl() );
    } catch( PartInitException e ) {
      e.printStackTrace();
    }
  }

  public void selectionChanged( final IAction action, final ISelection selection ) {
  }

  public void dispose() {
  }

  private static URL getUrl() {
    String helpURL = "http://{0}:{1}/index.jsp";
    Object[] param = new Object[]{
      RWT.getRequest().getServerName(),
      String.valueOf( RWT.getRequest().getServerPort() )
    };
    try {
      return new URL( MessageFormat.format( helpURL, param ) );
    } catch( MalformedURLException e ) {
      throw new IllegalArgumentException( "Failed to construct URL." );
    }
  }
}
